

!!! Listing 1: register.html

<html>
<head>
<title>XML-Register</title>

<xml id="daten" src="inhalt.xml"></xml>

<script src="error.js">
</script>

<script src="transform.js">
</script>

<script src="onload.js">
</script>

</head>
<body onLoad="window_onload()">

<h1>XML-Zeitschriftenregister</h1>
<table width="100%">
  <tr>
    <td><iframe id="register" height="400"></iframe></td>
    <td><iframe id="heft"     height="400"></iframe></td>
    <td><iframe id="artikel"  height="400"></iframe></td>
  </tr>
  <tr>
    <td></td>  
    <td></td>  
    <td>  
      <form>
        <input id="string" size="30">
        <input type="button" value="suchen" onClick="search_artikel(string.value)" >
      </form>
    </td>  
  </tr>

</table>

</body>
</html>

!!! Listing 2: Register-DTD	<--------- raus

<!ELEMENT register ( jahrgang* )>

<!ELEMENT jahrgang ( heft* )>
<!ATTLIST jahrgang 
          jahr        CDATA #REQUIRED
          zeitschrift CDATA #REQUIRED>

<!ELEMENT heft ( artikel* )>
<!ATTLIST heft  
          nr          CDATA #REQUIRED>

<!ELEMENT artikel ( titel, untertitel, autor, seite, schlagwort )>
<!ATTLIST artikel 
          id          CDATA #REQUIRED>

<!ELEMENT titel      ( #PCDATA )>
<!ELEMENT untertitel ( #PCDATA )>
<!ELEMENT autor      ( #PCDATA )>
<!ELEMENT seite      ( #PCDATA )>
<!ELEMENT schlagwort ( #PCDATA )>

!!! Listing 3: 

<?xml version="1.0" encoding="ISO-8859-1"?>
<register>
  <jahrgang jahr="83" zeitschrift="c">
    <heft nr="12">
      <artikel id="0">
        <titel>Scharfes Fernsehbild durch Videoeingang</titel>
        <untertitel>Heimfernseher als C-Monitor</untertitel>
        <autor>Gerd E. Neumann</autor>
        <seite>18</seite>
        <schlagwort>Praxistip</schlagwort>
      </artikel>
      <artikel id="1">
        <titel>Gestochen scharfes Bild</titel>
        <untertitel>Video-Ausgang fr ZX 81 und Jupiter ACE</untertitel>
        <autor>C. Persson/A. Burgwitz</autor>
        <seite>22</seite>
        <schlagwort>Praxistip</schlagwort>
      </artikel>
      <artikel id="2">
        <titel>Spectaculum a la carte</titel>
        <untertitel>Computertechnik prgte die IFA 1983</untertitel>
        <autor>Gerd E. Neumann</autor>
        <seite>24</seite>
        <schlagwort>Report</schlagwort>
      </artikel>

!!! Listing 4: onload.js

function makeProc(url)
{
    try 
    {
        var myXSL = new ActiveXObject("MSXML2.FreeThreadedDOMDocument");
        myXSL.async = false;
        myXSL.load(url);
        
        var myTemplate=new ActiveXObject("MSXML2.XSLTemplate");
        myTemplate.stylesheet = myXSL.documentElement;
        
        var myProc = myTemplate.createProcessor;
        myProc.input = daten.XMLDocument;
        return myProc;
    }
    catch (exception) 
    {
        register.document.open();
        register.document.write(myXSL && myXSL.parseError.errorCode ? reportParseError( myXSL.parseError ) : reportRuntimeError(exception, url) );
        register.document.close();
        return null;
    }
}

function window_onload()
{
    if (daten.parseError.errorCode != 0)
    {
      result = reportParseError(daten.parseError,"inhalt.xml");
      register.document.open();
      register.document.write( result );
      register.document.close();
      return;
    }
  
    RegisterProc = makeProc("register.xsl");
    HeftProc     = makeProc("heft.xsl");
    ArtikelProc  = makeProc("artikel.xsl");
    SearchProc   = makeProc("search.xsl");

    if ( RegisterProc == null || HeftProc == null || ArtikelProc == null || SearchProc == null )
       return;
       
    show_register();
}

!!! Listing 5: error.js


// Parse error formatting function
function reportParseError(error)
{
  var s = "";
  for (var i=1; i<error.linepos; i++) {
    s += " ";
  }
  r = "<font face=Verdana size=2><font size=4>XML Error loading '" + 
      error.url + "'</font>" +
      "<p><b>" + error.reason + 
      "</b></p></font>";
  if (error.line > 0)
    r += "<font size=3><xmp>" +
    "at line " + error.line + ", character " + error.linepos +
    "\n" + error.srcText +
    "\n" + s + "^" +
    "</xmp></font>";
  return r;
}

// Runtime error formatting function.
function reportRuntimeError(exception, url)
{
  return "<font face=Verdana size=2><font size=4>XSL Runtime Error at " + url + "</font>" +
      "<p><b>" + exception.description + "</b></p></font>";
}

!!! Listing 6: transform.js

// Die XSL-Prozessoren fr die verschiedenen Ansichten deklarieren
var RegisterProc;
var HeftProc;
var ArtikelProc;

function show_register()
{
RegisterProc.transform();
register.document.open();
register.document.write(RegisterProc.output);
register.document.close();
}

function show_heft(z,j,h)
{
HeftProc.addParameter("zeitschrift",z);
HeftProc.addParameter("jahr",j);
HeftProc.addParameter("heft",h);
HeftProc.transform();
heft.document.open();
heft.document.write(HeftProc.output);
heft.document.close();
}

function show_artikel(id)
{
ArtikelProc.addParameter("id",id);
ArtikelProc.transform();
artikel.document.open();
artikel.document.write(ArtikelProc.output);
artikel.document.close();
}

function search_artikel(string)
{
SearchProc.addParameter("string",string);
SearchProc.transform();
artikel.document.open();
artikel.document.write(SearchProc.output);
artikel.document.close();
}

!!! Listing 7: register.xsl

<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:template match="/register">
  <h2>c't</h2>
  <table>
    <xsl:apply-templates select="jahrgang[@zeitschrift='c']"/>
  </table>  
  
  <h2>iX</h2>
  <table>
    <xsl:apply-templates select="jahrgang[@zeitschrift='i']"/>
  </table>  

</xsl:template>

<xsl:template match="jahrgang">
  <tr>
    <td>
      <xsl:value-of select="@jahr"/>
    </td>
    <xsl:apply-templates select="heft"/>
  </tr>  
</xsl:template>

<xsl:template match="heft">
  <td>
    <a>
    <xsl:attribute name="href">javascript:top.show_heft('<xsl:value-of select="../@zeitschrift"/>','<xsl:value-of select="../@jahr"/>',<xsl:value-of select="@nr"/>)</xsl:attribute>
    <xsl:value-of select="@nr"/>
    </a>
  </td>
</xsl:template>

</xsl:stylesheet>               

!!! Listing 8: heft.xsl

<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:param name="jahr"/>
<xsl:param name="zeitschrift"/>
<xsl:param name="heft"/>

<xsl:template match="/">
  <h2>
    Heft 
    <xsl:choose>
      <xsl:when test="$zeitschrift='c'">c't</xsl:when>
      <xsl:when test="$zeitschrift='i'">iX</xsl:when>
      <xsl:otherwise>???</xsl:otherwise>
    </xsl:choose>
        
    <xsl:text> </xsl:text>
    
    <xsl:value-of select="$heft"/>/<xsl:value-of select="$jahr"/>
  </h2>
  <table>
    <tr>
      <th>Titel</th>
      <th>Seite</th>
    </tr>  
    <xsl:apply-templates select="//jahrgang[@jahr=$jahr and @zeitschrift=$zeitschrift]/heft[@nr=$heft]/artikel">
      <xsl:sort select="seite" data-type="number"/>
    </xsl:apply-templates>
  </table>  

</xsl:template>

<xsl:template match="artikel">
  <tr>
    <td>
      <a>
      <xsl:attribute name="href">javascript:top.show_artikel(<xsl:value-of select="@id"/>)</xsl:attribute>
      <xsl:value-of select="titel"/>
      </a>
    </td>
    <td align="right">
      <xsl:value-of select="seite"/>
    </td>
  </tr>  
</xsl:template>

</xsl:stylesheet>               

!!! Listing 9: artikel.xsl

<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:param name="id"/>

<xsl:template match="/">
  <xsl:apply-templates select="//artikel[@id=$id]"/>

</xsl:template>

<xsl:template match="artikel">
  <h2>
    Artikel Heft 
    <xsl:choose>
      <xsl:when test="../../@zeitschrift='c'">c't</xsl:when>
      <xsl:when test="../../@zeitschrift='i'">iX</xsl:when>
      <xsl:otherwise>???</xsl:otherwise>
    </xsl:choose>
            
    <xsl:text> </xsl:text>

    <xsl:value-of select="../@nr"/>/<xsl:value-of select="../../@jahr"/>, 
    <br/>Seite <xsl:value-of select="seite"/>
  </h2>  

  <table>
    <tr>
      <th valign="top" align="left">Autor:</th>
      <td><xsl:value-of select="autor"/></td>
    </tr>  
    <tr>
      <th valign="top" align="left">Titel:</th>
      <td><xsl:value-of select="titel"/></td>
    </tr>  
    <tr>
      <th valign="top" align="left">Untertitel:</th>
      <td><xsl:value-of select="untertitel"/></td>
    </tr>  
    <tr>
      <th valign="top" align="left">Schlagworte:</th>
      <td><xsl:value-of select="schlagwort"/></td>
    </tr>  
  </table> 
</xsl:template>

</xsl:stylesheet>               

!!! Listing 10: search.xsl

<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:import href="artikel.xsl"/>

<xsl:param name="string"/>

<xsl:template match="/">
  <xsl:apply-templates select="//artikel[contains(titel,$string) or contains(untertitel,$string) or contains(schlagwort,$string)]"/>
</xsl:template>

</xsl:stylesheet>               

!!! Listing 11: convert.pl

use strict;
use Win32::OLE;

# encoding wandelt den DOS-Zeichensatz der 
# Registerdatei in den ANSI-Zeichensatz um

sub encoding {
  my $str = shift;

  $str =~ tr/\x02\x04/\x82\x84/;  # Da sind die 8. Bits verschwunden...
  $str =~ tr/\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF/\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\xEC\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\xFF\xD6\xDC\xF8\xA3\xD8\xD7\x83\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\xAE\xAC\xBD\xBC\xA1\xAB\xBB\xA6\xA6\xA6\xA6\xA6\xC1\xC2\xC0\xA9\xA6\xA6\x2B\x2B\xA2\xA5\x2B\x2B\x2D\x2D\x2B\x2D\x2B\xE3\xC3\x2B\x2B\x2D\x2D\xA6\x2D\x2B\xA4\xF0\xD0\xCA\xCB\xC8\x69\xCD\xCE\xCF\x2B\x2B\xA6\x5F\xA6\xCC\xAF\xD3\xDF\xD4\xD2\xF5\xD5\xB5\xFE\xDE\xDA\xDB\xD9\xFD\xDD\xAF\xB4\xAD\xB1\x3D\xBE\xB6\xA7\xF7\xB8\xB0\xA8\xB7\xB9\xB3\xB2\xA6\xA0/;

  return $str;
}

# ein leeres DOMDocument anlegen
# und den Wurzelknoten erzeugen

my $xmldoc = Win32::OLE->new('Msxml2.DOMDocument') or die "Kann DOMDocument nicht anlegen.\n";

my $pi = $xmldoc->createProcessingInstruction('xml', 'version="1.0" encoding="ISO-8859-1"');
$xmldoc->appendChild( $pi );

my $xmlregister = $xmldoc->createElement('register');
$xmldoc->appendChild( $xmlregister );

my $id=0;

# Datensaetze aus der Registerdatei einlesen
# Zeichensatz konvertieren 
# bei numerischen Angaben Leerzeichen wegwerfen.

open( INHALT, '<INHALT.FRM') or die 'Kann INHALT.FRM nicht oeffnen.';

while ( my $titel = <INHALT> ) {
                               chomp( $titel      ); $titel      = encoding( $titel      );  
    my $untertitel = <INHALT>; chomp( $untertitel ); $untertitel = encoding( $untertitel );  
    my $autor      = <INHALT>; chomp( $autor      ); $autor      = encoding( $autor      );  
    <INHALT>;   # Redakteur
    my $seite      = <INHALT>; chomp( $seite      ); $seite      *= 1;  
    my $ausgabe    = <INHALT>; chomp( $ausgabe    ); $ausgabe    *= 1;  
    my $jahrgang   = <INHALT>; chomp( $jahrgang   ); $jahrgang   = encoding( $jahrgang   );  
    <INHALT>;   # Querverweise
    my $schlagwort = <INHALT>; chomp( $schlagwort ); $schlagwort = encoding( $schlagwort );  

    my ($zeitschrift,$jahr) = ( $jahrgang =~ /^(.)(\d+)/ );

    # nachschauen, ob das Heft bereits eingetragen ist

    my $xmlausgabe = $xmlregister->selectSingleNode("jahrgang[\@jahr='$jahr' and \@zeitschrift='$zeitschrift']/heft[\@nr='$ausgabe']");
    if ( !$xmlausgabe ) {

        # Ein neues Heft hat begonnen. Neuen ausgabe-Knoten mit Attributen einfuegen
        # ggf. neuen Jahrgang anlegen.
        print "$zeitschrift$jahr/$ausgabe\n";

        my $xmljahrgang = $xmlregister->selectSingleNode("jahrgang[\@jahr='$jahr' and \@zeitschrift='$zeitschrift']");
        if ( !$xmljahrgang ) {
            # einen neuen Jahrgang anlegen
            $xmljahrgang = $xmldoc->createElement('jahrgang');
            $xmljahrgang->SetAttribute( 'jahr', $jahr );
            $xmljahrgang->SetAttribute( 'zeitschrift', $zeitschrift );
            $xmlregister->appendChild( $xmljahrgang );
        }

        $xmlausgabe = $xmldoc->createElement('heft');
        $xmlausgabe->SetAttribute( 'nr', $ausgabe );
        $xmljahrgang->appendChild( $xmlausgabe );
    }

    # nun den artikel-Knoten aufbauen
    my ($xmlartikel,$xmltext,$xmltextnode);
    
    $xmlartikel = $xmldoc->createElement('artikel');
    $xmlartikel->SetAttribute( 'id', $id++ );
    $xmlausgabe->appendChild( $xmlartikel );

    $xmltext = $xmldoc->createElement('titel');
    $xmlartikel->appendChild( $xmltext );
    $xmltextnode = $xmldoc->createTextNode( $titel );
    $xmltext->appendChild( $xmltextnode );

    $xmltext = $xmldoc->createElement('untertitel');
    $xmlartikel->appendChild( $xmltext );
    $xmltextnode = $xmldoc->createTextNode( $untertitel );
    $xmltext->appendChild( $xmltextnode );

    $xmltext = $xmldoc->createElement('autor');
    $xmlartikel->appendChild( $xmltext );
    $xmltextnode = $xmldoc->createTextNode( $autor );
    $xmltext->appendChild( $xmltextnode );

    $xmltext = $xmldoc->createElement('seite');
    $xmlartikel->appendChild( $xmltext );
    $xmltextnode = $xmldoc->createTextNode( $seite );
    $xmltext->appendChild( $xmltextnode );

    $xmltext = $xmldoc->createElement('schlagwort');
    $xmlartikel->appendChild( $xmltext );
    $xmltextnode = $xmldoc->createTextNode( $schlagwort );
    $xmltext->appendChild( $xmltextnode );

    # ein Zeilenvorschub, damit XML-Datei im Editor lesbar ist
    $xmltextnode = $xmldoc->createTextNode( "\n" );
    $xmlausgabe->appendChild( $xmltextnode );

}

# und das DOMDocument auf Platte schreiben

$xmldoc->save('inhalt.xml');
